import { Render, SuperRender, Rtti, AbstractNodeInstance, NodeInfo } from './Data';
export declare class NodeInstance<E = unknown, O = void> implements AbstractNodeInstance<E, O> {
    private static gUuid;
    readonly uuid: number;
    readonly level: number;
    revision: number;
    native?: E;
    model?: unknown;
    children: ReadonlyArray<NodeInfo<any, any>>;
    buffer: Array<NodeInfo<any, any>> | undefined;
    aliens: ReadonlyArray<NodeInfo<any, any>>;
    resizing?: ResizeObserver;
    constructor(level: number);
    render(node: NodeInfo<E, O>): void;
}
export declare class RxDom {
    static readonly ROOT: NodeInfo<unknown, void>;
    static gOwner: NodeInfo<any, any>;
    static gHost: NodeInfo<any, any>;
    static gTrace: string | undefined;
    static gTraceMask: string;
    static Root<T>(render: () => T): T;
    static Node<E = unknown, O = void>(id: string, args: any, render: Render<E, O>, superRender?: SuperRender<O, E>, priority?: number, rtti?: Rtti<E, O>, owner?: NodeInfo, host?: NodeInfo): NodeInfo<E, O>;
    static wrap(func: (...args: any[]) => any): (...args: any[]) => any;
    static runUnder(owner: NodeInfo, host: NodeInfo, func: (...args: any[]) => any, ...args: any[]): any;
    static render(node: NodeInfo<any, any>): void;
    static renderChildrenThenDo(action: () => void): void;
    static initialize(node: NodeInfo): void;
    static finalize(node: NodeInfo<any, any>, cause: NodeInfo): void;
    static usingAnotherHost<E>(host: NodeInfo<E>, run: (e: E) => void): void;
    static createRootNode<E>(id: string, sequential: boolean, native: E): NodeInfo<E>;
    static currentNodeInstance<T>(): {
        model?: T;
    };
    static currentNodeInstanceInternal<E>(): NodeInstance<E>;
    static currentNodeRevision(): number;
    static setTraceMode(enabled: boolean, mask: string, regexp: string): void;
    static forAll<E>(action: (e: E) => void): void;
    static renderUsingRttiOrDirectly<E, O>(instance: NodeInstance<E, O>, node: NodeInfo<E, O>): void;
    private static doRender;
    private static doInitialize;
    private static doFinalize;
    private static mergeAndRenderSequentialChildren;
    private static mergeAndRenderChildren;
    private static renderIncrementally;
    private static mergeAliens;
    private static forEachChildRecursively;
}
export declare function resolveReturn(value: any): any;
export declare function rejectRethrow(error: any): never;
