"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.rejectRethrow = exports.resolveReturn = exports.RxDom = exports.NodeInstance = void 0;
const reactronic_1 = require("reactronic");
const Data_1 = require("./Data");
const EMPTY = Object.freeze([]);
const DEFAULT_RTTI = { name: 'RxDom.Node', sequential: false };
const NOP = () => { };
class NodeInstance {
    constructor(level) {
        this.revision = 0;
        this.native = undefined;
        this.model = undefined;
        this.children = EMPTY;
        this.buffer = undefined;
        this.aliens = EMPTY;
        this.resizing = undefined;
        this.uuid = ++NodeInstance.gUuid;
        this.level = level;
    }
    render(node) {
        RxDom.renderUsingRttiOrDirectly(this, node);
        reactronic_1.Rx.configureCurrentOperation({ order: this.level });
    }
}
NodeInstance.gUuid = 0;
__decorate([
    reactronic_1.reaction,
    (0, reactronic_1.options)({
        reentrance: reactronic_1.Reentrance.CancelPrevious,
        sensitiveArgs: true,
        noSideEffects: true
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Data_1.NodeInfo]),
    __metadata("design:returntype", void 0)
], NodeInstance.prototype, "render", null);
exports.NodeInstance = NodeInstance;
class RxDom {
    static Root(render) {
        const self = RxDom.ROOT.instance;
        if (self.buffer)
            throw new Error('rendering re-entrance is not supported yet');
        self.buffer = [];
        let result = render();
        if (result instanceof Promise)
            result = result.then(value => { reactronic_1.Transaction.run(RxDom.renderChildrenThenDo, NOP); return value; }, error => { console.log(error); reactronic_1.Transaction.run(RxDom.renderChildrenThenDo, NOP); });
        else
            reactronic_1.Transaction.run(RxDom.renderChildrenThenDo, NOP);
        return result;
    }
    static Node(id, args, render, superRender, priority, rtti, owner, host) {
        var _a, _b;
        const o = owner !== null && owner !== void 0 ? owner : RxDom.gOwner;
        const h = host !== null && host !== void 0 ? host : RxDom.gHost;
        const self = o.instance;
        if (!self)
            throw new Error('element must be initialized before children');
        const node = new Data_1.NodeInfo(id, args, render, superRender, priority !== null && priority !== void 0 ? priority : 0, rtti !== null && rtti !== void 0 ? rtti : DEFAULT_RTTI, o, h);
        if (self.buffer === undefined)
            throw new Error('children are rendered already');
        const rev = (_b = (_a = h === null || h === void 0 ? void 0 : h.instance) === null || _a === void 0 ? void 0 : _a.revision) !== null && _b !== void 0 ? _b : -1;
        if (rev >= 0)
            self.buffer.push(node);
        return node;
    }
    static wrap(func) {
        const owner = RxDom.gOwner;
        const host = RxDom.gHost;
        const wrappedRendering = (...args) => {
            return RxDom.runUnder(owner, host, func, ...args);
        };
        return wrappedRendering;
    }
    static runUnder(owner, host, func, ...args) {
        const outerOwner = RxDom.gOwner;
        const outerHost = RxDom.gHost;
        try {
            RxDom.gOwner = owner;
            RxDom.gHost = host;
            return func(...args);
        }
        finally {
            RxDom.gHost = outerHost;
            RxDom.gOwner = outerOwner;
        }
    }
    static render(node) {
        var _a;
        const self = node.instance;
        if (!self)
            throw new Error('element must be initialized before rendering');
        if (self.buffer)
            throw new Error('rendering re-entrance is not supported yet');
        const outerOwner = RxDom.gOwner;
        const outerHost = RxDom.gHost;
        try {
            RxDom.gOwner = node;
            RxDom.gHost = self.native ? node : node.host;
            self.buffer = [];
            if (RxDom.gTrace && RxDom.gTraceMask.indexOf('r') >= 0 && new RegExp(RxDom.gTrace, 'gi').test(getTraceHint(node)))
                console.log(`t${reactronic_1.Transaction.current.id}v${reactronic_1.Transaction.current.timestamp}${'  '.repeat(Math.abs(node.instance.level))}${getTraceHint(node)}.render/${(_a = node.instance) === null || _a === void 0 ? void 0 : _a.revision}${node.args !== Data_1.RefreshParent ? `  <<  ${reactronic_1.Rx.why(true)}` : ''}`);
            let result;
            if (node.superRender)
                result = node.superRender(options => {
                    const res = node.render(self.native, options);
                    if (res instanceof Promise)
                        return res.then();
                    else
                        return options;
                }, self.native);
            else
                result = node.render(self.native, undefined);
            if (result instanceof Promise)
                result = result.then(value => { RxDom.renderChildrenThenDo(NOP); return value; }, error => { console.log(error); RxDom.renderChildrenThenDo(NOP); });
            else
                RxDom.renderChildrenThenDo(NOP);
        }
        finally {
            RxDom.gHost = outerHost;
            RxDom.gOwner = outerOwner;
        }
    }
    static renderChildrenThenDo(action) {
        const node = RxDom.gOwner;
        if (node.rtti.sequential)
            RxDom.mergeAndRenderSequentialChildren(node, action);
        else
            RxDom.mergeAndRenderChildren(node, action);
    }
    static initialize(node) {
        RxDom.doInitialize(node);
    }
    static finalize(node, cause) {
        const self = node.instance;
        if (self && self.revision >= 0) {
            self.revision = -self.revision;
            self.native = undefined;
            for (const x of self.children)
                RxDom.doFinalize(x, cause);
            for (const x of self.aliens)
                RxDom.doFinalize(x, cause);
        }
    }
    static usingAnotherHost(host, run) {
        var _a;
        const native = (_a = host.instance) === null || _a === void 0 ? void 0 : _a.native;
        if (native !== undefined) {
            const outer = RxDom.gHost;
            try {
                RxDom.gHost = host;
                run(native);
            }
            finally {
                RxDom.gHost = outer;
            }
        }
    }
    static createRootNode(id, sequential, native) {
        const self = new NodeInstance(0);
        const node = new Data_1.NodeInfo(id, null, () => { }, undefined, 0, { name: id, sequential }, {}, {}, self);
        const a = node;
        a['owner'] = node;
        a['host'] = node;
        self.native = native;
        return node;
    }
    static currentNodeInstance() {
        const self = RxDom.gOwner.instance;
        if (!self)
            throw new Error('currentNodeInstance function can be called only inside rendering function');
        return self;
    }
    static currentNodeInstanceInternal() {
        const self = RxDom.gOwner.instance;
        if (!self)
            throw new Error('currentNodeInstanceInternal function can be called only inside rendering function');
        return self;
    }
    static currentNodeRevision() {
        var _a, _b;
        return (_b = (_a = RxDom.gOwner.instance) === null || _a === void 0 ? void 0 : _a.revision) !== null && _b !== void 0 ? _b : 0;
    }
    static setTraceMode(enabled, mask, regexp) {
        RxDom.gTrace = enabled ? regexp : undefined;
        RxDom.gTraceMask = mask;
    }
    static forAll(action) {
        RxDom.forEachChildRecursively(RxDom.ROOT, action);
    }
    static renderUsingRttiOrDirectly(instance, node) {
        instance.revision++;
        node.rtti.render ? node.rtti.render(node) : RxDom.render(node);
    }
    static doRender(node) {
        const self = node.instance;
        if (node.args === Data_1.RefreshParent)
            RxDom.renderUsingRttiOrDirectly(self, node);
        else
            (0, reactronic_1.nonreactive)(self.render, node);
    }
    static doInitialize(node) {
        var _a, _b;
        const rtti = node.rtti;
        const self = node.instance = new NodeInstance(node.owner.instance.level + 1);
        (_a = rtti.initialize) === null || _a === void 0 ? void 0 : _a.call(rtti, node);
        (_b = rtti.mount) === null || _b === void 0 ? void 0 : _b.call(rtti, node);
        if (node.args !== Data_1.RefreshParent)
            reactronic_1.Rx.setTraceHint(self, reactronic_1.Rx.isTraceEnabled ? getTraceHint(node) : node.id);
        if (RxDom.gTrace && RxDom.gTraceMask.indexOf('m') >= 0 && new RegExp(RxDom.gTrace, 'gi').test(getTraceHint(node)))
            console.log(`t${reactronic_1.Transaction.current.id}v${reactronic_1.Transaction.current.timestamp}${'  '.repeat(Math.abs(node.instance.level))}${getTraceHint(node)}.initialized`);
        return self;
    }
    static doFinalize(node, cause) {
        if (RxDom.gTrace && RxDom.gTraceMask.indexOf('u') >= 0 && new RegExp(RxDom.gTrace, 'gi').test(getTraceHint(node)))
            console.log(`t${reactronic_1.Transaction.current.id}v${reactronic_1.Transaction.current.timestamp}${'  '.repeat(Math.abs(node.instance.level))}${getTraceHint(node)}.finalizing`);
        if (node.args !== Data_1.RefreshParent && node.instance)
            reactronic_1.Transaction.runAs({ standalone: true }, () => reactronic_1.Rx.dispose(node.instance));
        const rtti = node.rtti;
        if (rtti.finalize)
            rtti.finalize(node, cause);
        else
            RxDom.finalize(node, cause);
    }
    static mergeAndRenderSequentialChildren(node, finish) {
        var _a, _b, _c;
        const self = node.instance;
        if (self !== undefined && self.buffer !== undefined) {
            let promised = undefined;
            try {
                const existing = self.children;
                const sequenced = self.buffer;
                const sorted = sequenced.slice().sort(compareNodes);
                self.buffer = undefined;
                let host = self;
                let aliens = EMPTY;
                let sibling = undefined;
                let i = 0, j = 0;
                while (i < existing.length) {
                    const old = existing[i];
                    const x = sorted[j];
                    const diff = x !== undefined ? compareNodes(x, old) : 1;
                    if (diff <= 0) {
                        const h = x.host.instance;
                        if (h !== self) {
                            if (h !== host) {
                                RxDom.mergeAliens(host, self, aliens);
                                aliens = [];
                                host = h;
                            }
                            aliens.push(x);
                        }
                        if (sibling !== undefined && x.id === sibling.id)
                            throw new Error(`duplicate id '${sibling.id}' inside '${node.id}'`);
                        if (diff === 0) {
                            x.instance = old.instance;
                            x.old = old;
                            i++, j++;
                        }
                        else
                            j++;
                        sibling = x;
                    }
                    else {
                        if (!reactronic_1.Transaction.isCanceled)
                            RxDom.doFinalize(old, old);
                        i++;
                    }
                }
                if (host !== self)
                    RxDom.mergeAliens(host, self, aliens);
                sibling = undefined;
                i = 0, j = -1;
                while (i < sequenced.length && !reactronic_1.Transaction.isCanceled) {
                    const x = sequenced[i];
                    const old = x.old;
                    x.old = undefined;
                    x.sibling = sibling;
                    const instance = x.instance;
                    if (old && instance) {
                        if ((sibling === null || sibling === void 0 ? void 0 : sibling.instance) !== ((_a = old.sibling) === null || _a === void 0 ? void 0 : _a.instance))
                            (_c = (_b = x.rtti).mount) === null || _c === void 0 ? void 0 : _c.call(_b, x);
                        if (x.args === Data_1.RefreshParent || !argsAreEqual(x.args, old.args))
                            RxDom.doRender(x);
                    }
                    else {
                        RxDom.doInitialize(x);
                        RxDom.doRender(x);
                    }
                    if (x.native)
                        sibling = x;
                    if (x.priority > 0 && j < 0)
                        j = i;
                    i++;
                }
                if (!reactronic_1.Transaction.isCanceled) {
                    self.children = sorted;
                    if (j >= 0)
                        promised = RxDom.renderIncrementally(node, sequenced, j).then(finish, finish);
                }
            }
            finally {
                if (promised)
                    finish();
            }
        }
    }
    static mergeAndRenderChildren(node, finish) {
        const self = node.instance;
        if (self !== undefined && self.buffer !== undefined) {
            let promised = undefined;
            try {
                const existing = self.children;
                const buffer = self.buffer.sort(compareNodes);
                const postponed = new Array();
                self.buffer = undefined;
                let host = self;
                let aliens = EMPTY;
                let sibling = undefined;
                let i = 0, j = 0;
                while (i < existing.length || j < buffer.length) {
                    const old = existing[i];
                    const x = buffer[j];
                    const diff = compareNullable(x, old, compareNodes);
                    if (diff <= 0) {
                        const h = x.host.instance;
                        if (h !== self) {
                            if (h !== host) {
                                RxDom.mergeAliens(host, self, aliens);
                                aliens = [];
                                host = h;
                            }
                            aliens.push(x);
                        }
                        if (sibling !== undefined && x.id === sibling.id)
                            throw new Error(`duplicate id '${sibling.id}' inside '${node.id}'`);
                        if (diff === 0) {
                            if (old.instance) {
                                x.instance = old.instance;
                                if (x.args === Data_1.RefreshParent || !argsAreEqual(x.args, old.args)) {
                                    if (!reactronic_1.Transaction.isCanceled) {
                                        if (x.priority === 0)
                                            RxDom.doRender(x);
                                        else
                                            postponed.push(x);
                                    }
                                }
                            }
                            else {
                                if (!reactronic_1.Transaction.isCanceled) {
                                    if (x.priority === 0) {
                                        RxDom.doInitialize(x);
                                        RxDom.doRender(x);
                                    }
                                    else
                                        postponed.push(x);
                                }
                            }
                            i++, j++;
                        }
                        else {
                            if (!reactronic_1.Transaction.isCanceled) {
                                if (x.priority === 0) {
                                    RxDom.doInitialize(x);
                                    RxDom.doRender(x);
                                }
                                else
                                    postponed.push(x);
                            }
                            j++;
                        }
                        sibling = x;
                    }
                    else {
                        if (!reactronic_1.Transaction.isCanceled)
                            RxDom.doFinalize(old, old);
                        i++;
                    }
                }
                if (host !== self)
                    RxDom.mergeAliens(host, self, aliens);
                if (!reactronic_1.Transaction.isCanceled) {
                    self.children = buffer;
                    if (postponed.length > 0)
                        promised = RxDom.renderIncrementally(node, postponed, 0).then(finish, finish);
                }
            }
            finally {
                if (!promised)
                    finish();
            }
        }
    }
    static renderIncrementally(parent, children, startIndex, checkEveryN = 30, timeLimit = 12) {
        return __awaiter(this, void 0, void 0, function* () {
            if (reactronic_1.Transaction.isFrameOver(checkEveryN, timeLimit))
                yield reactronic_1.Transaction.requestNextFrame();
            if (!reactronic_1.Transaction.isCanceled) {
                children.sort(compareNodesByPriority);
                let i = startIndex;
                while (i < children.length) {
                    const x = children[i];
                    if (!x.instance)
                        RxDom.doInitialize(x);
                    RxDom.doRender(x);
                    if (reactronic_1.Transaction.isCanceled)
                        break;
                    if (reactronic_1.Transaction.isFrameOver(checkEveryN, timeLimit))
                        yield reactronic_1.Transaction.requestNextFrame();
                    if (reactronic_1.Transaction.isCanceled)
                        break;
                    i++;
                }
            }
        });
    }
    static mergeAliens(host, owner, aliens) {
        if (host !== owner) {
            const existing = host.aliens;
            const merged = [];
            let i = 0, j = 0;
            while (i < existing.length || j < aliens.length) {
                const old = existing[i];
                const x = aliens[j];
                const diff = compareNullable(x, old, compareNodes);
                if (diff <= 0) {
                    merged.push(x);
                    if (diff === 0)
                        i++, j++;
                    else
                        j++;
                }
                else {
                    if (old.owner.instance !== owner)
                        merged.push(old);
                    i++;
                }
            }
            host.aliens = merged;
        }
    }
    static forEachChildRecursively(node, action) {
        const self = node.instance;
        if (self) {
            const native = self.native;
            native && action(native);
            self.children.forEach(x => RxDom.forEachChildRecursively(x, action));
        }
    }
}
exports.RxDom = RxDom;
RxDom.ROOT = RxDom.createRootNode('ROOT', false, 'ROOT');
RxDom.gOwner = RxDom.ROOT;
RxDom.gHost = RxDom.ROOT;
RxDom.gTrace = undefined;
RxDom.gTraceMask = 'r';
function compareNodes(node1, node2) {
    let result = 0;
    const hp1 = node1.host.instance;
    const hp2 = node2.host.instance;
    if (hp1 !== hp2) {
        result = hp1.uuid - hp2.uuid;
        if (result === 0)
            result = node1.id.localeCompare(node2.id);
    }
    else
        result = node1.id.localeCompare(node2.id);
    return result;
}
function compareNodesByPriority(node1, node2) {
    return node1.priority - node2.priority;
}
function compareNullable(a, b, comparer) {
    let diff;
    if (b !== undefined)
        diff = a !== undefined ? comparer(a, b) : 1;
    else
        diff = a !== undefined ? -1 : 0;
    return diff;
}
function argsAreEqual(a1, a2) {
    let result = a1 === a2;
    if (!result) {
        if (Array.isArray(a1)) {
            result = Array.isArray(a2) &&
                a1.length === a2.length &&
                a1.every((t, i) => t === a2[i]);
        }
        else if (a1 === Object(a1) && a2 === Object(a2)) {
            for (const p in a1) {
                result = a1[p] === a2[p];
                if (!result)
                    break;
            }
        }
    }
    return result;
}
function getTraceHint(node) {
    return `${node.rtti.name}:${node.id}`;
}
const ORIGINAL_PROMISE_THEN = Promise.prototype.then;
function reactronicFrontHookedThen(resolve, reject) {
    resolve = resolve ? RxDom.wrap(resolve) : resolveReturn;
    reject = reject ? RxDom.wrap(reject) : rejectRethrow;
    return ORIGINAL_PROMISE_THEN.call(this, resolve, reject);
}
function resolveReturn(value) {
    return value;
}
exports.resolveReturn = resolveReturn;
function rejectRethrow(error) {
    throw error;
}
exports.rejectRethrow = rejectRethrow;
Promise.prototype.then = reactronicFrontHookedThen;
