import { NodeInfo, Rtti } from '../core/api';
export declare abstract class AbstractHtmlRtti<E extends Element> implements Rtti<E, any> {
    readonly name: string;
    readonly sequential: boolean;
    static isDebugAttributeEnabled: boolean;
    static gNativeParent: NodeInfo<any, any>;
    static gSubTreeFinalization?: Element;
    private static _blinkingEffect;
    constructor(name: string, sequential?: boolean);
    initialize(node: NodeInfo<E, any>): void;
    mount(node: NodeInfo<E, any>): void;
    render(node: NodeInfo<E, any>): void;
    finalize(node: NodeInfo<E, any>, cause: NodeInfo): void;
    static get blinkingEffect(): string | undefined;
    static set blinkingEffect(value: string | undefined);
    protected abstract createElement(m: NodeInfo<E, any>): E;
}
export declare class HtmlRtti<E extends HTMLElement> extends AbstractHtmlRtti<E> {
    protected createElement(node: NodeInfo<E, any>): E;
}
export declare class SvgRtti<E extends SVGElement> extends AbstractHtmlRtti<E> {
    protected createElement(node: NodeInfo<E, any>): E;
}
