"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RxFocus = exports.TwoWayFocusSync = void 0;
const reactronic_1 = require("reactronic");
const api_1 = require("../core/api");
function TwoWayFocusSync(id, target, focusToggle, setNativeFocus) {
    target.dataForSensor.focus = focusToggle;
    if (setNativeFocus === undefined)
        setNativeFocus = () => target.focus();
    api_1.RxDom.Node(id, { focusToggle }, () => {
        const f = focusToggle.value;
        const f1 = focusToggle.valueOn;
        const active = f === focusToggle.valueOn || (f instanceof reactronic_1.Ref && f1 instanceof reactronic_1.Ref && reactronic_1.Ref.sameRefs(f, f1));
        if (active && setNativeFocus)
            setNativeFocus();
    });
}
exports.TwoWayFocusSync = TwoWayFocusSync;
function RxFocus(id, target, focusToggle) {
    api_1.RxDom.Node(id, { target, focusToggle }, () => {
        target.dataForSensor.focus = focusToggle;
        const value = focusToggle.value;
        const valueOn = focusToggle.valueOn;
        const active = value === valueOn ||
            (value instanceof reactronic_1.Ref && valueOn instanceof reactronic_1.Ref && reactronic_1.Ref.sameRefs(value, valueOn));
        if (active)
            target.focus();
    });
}
exports.RxFocus = RxFocus;
