"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPointerButtonDown = exports.extractPointerButton = exports.BasePointerSensor = exports.PointerButton = void 0;
const HtmlElementSensor_1 = require("./HtmlElementSensor");
const KeyboardSensor_1 = require("./KeyboardSensor");
var PointerButton;
(function (PointerButton) {
    PointerButton[PointerButton["None"] = 0] = "None";
    PointerButton[PointerButton["Left"] = 1] = "Left";
    PointerButton[PointerButton["Right"] = 2] = "Right";
    PointerButton[PointerButton["Middle"] = 4] = "Middle";
})(PointerButton = exports.PointerButton || (exports.PointerButton = {}));
class BasePointerSensor extends HtmlElementSensor_1.HtmlElementSensor {
    constructor(window) {
        super(window);
        this.positionX = Infinity;
        this.positionY = Infinity;
        this.modifiers = KeyboardSensor_1.KeyboardModifiers.None;
    }
}
exports.BasePointerSensor = BasePointerSensor;
function extractPointerButton(e) {
    switch (e.button) {
        case 0:
            return PointerButton.Left;
        case 1:
            return PointerButton.Middle;
        case 2:
            return PointerButton.Right;
        default:
            return PointerButton.None;
    }
}
exports.extractPointerButton = extractPointerButton;
function isPointerButtonDown(button, buttonsMask) {
    return (buttonsMask & button) !== 0;
}
exports.isPointerButtonDown = isPointerButtonDown;
