import { PointerButton, BasePointerSensor } from './BasePointerSensor';
import { WindowSensor } from './WindowSensor';
export declare enum ButtonState {
    Pressed = 0,
    Selecting = 1,
    Selected = 2,
    Released = 3
}
export declare class ButtonSensor extends BasePointerSensor {
    state: ButtonState;
    pointerButton: PointerButton;
    originData: unknown;
    selectedData: unknown;
    selectedX: number;
    selectedY: number;
    selected: boolean;
    constructor(windowSensor: WindowSensor);
    listen(element: HTMLElement | undefined, enabled?: boolean): void;
    protected onPointerDown(e: PointerEvent): void;
    protected onPointerMove(e: PointerEvent): void;
    protected onPointerUp(e: PointerEvent): void;
    protected onLostPointerCapture(e: PointerEvent): void;
    protected onKeyDown(e: KeyboardEvent): void;
    protected press(e: PointerEvent): void;
    protected selecting(e: PointerEvent): void;
    protected select(e: PointerEvent): void;
    protected release(): void;
    protected cancel(): void;
    protected reset(): void;
    protected updateSensorData(e: PointerEvent): void;
}
