"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findTargetElementData = exports.grabElementData = exports.EmptyDataArray = exports.SymDataForSensor = void 0;
exports.SymDataForSensor = Symbol('DataForSensor');
exports.EmptyDataArray = [];
function grabElementData(targetPath, sym, payloadKey, existing) {
    let result = existing;
    let i = 0;
    let j = 0;
    let window = undefined;
    while (window === undefined && i < targetPath.length) {
        const data = targetPath[i][sym];
        if (data !== undefined) {
            window = data['window'];
            const payload = data[payloadKey];
            if (payload !== undefined) {
                if (result !== existing)
                    payload !== undefined && result.push(payload);
                else if (payload !== undefined) {
                    if (payload !== existing[j]) {
                        result = existing.slice(0, j);
                        result.push(payload);
                    }
                    else
                        j++;
                }
                else {
                    result = existing.slice(0, j);
                }
            }
        }
        i++;
    }
    if (j === 0 && result === existing && existing.length > 0)
        result = exports.EmptyDataArray;
    return { data: result, window };
}
exports.grabElementData = grabElementData;
function findTargetElementData(targetPath, underPointer, sym, anyOfPayloadKeys) {
    let result = undefined;
    let i = 0;
    let window = undefined;
    while (window === undefined && i < targetPath.length) {
        const candidate = targetPath[i];
        const candidateData = candidate[sym];
        if (candidateData !== undefined) {
            window = candidateData['window'];
            if (result === undefined) {
                for (const payloadKey of anyOfPayloadKeys) {
                    const payload = candidateData[payloadKey];
                    if (payload !== undefined && underPointer.includes(candidate)) {
                        result = candidateData;
                        break;
                    }
                }
            }
        }
        i++;
    }
    return { data: result, window };
}
exports.findTargetElementData = findTargetElementData;
