"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FocusSensor = void 0;
const reactronic_1 = require("reactronic");
const DataForSensor_1 = require("./DataForSensor");
const HtmlElementSensor_1 = require("./HtmlElementSensor");
class FocusSensor extends HtmlElementSensor_1.HtmlElementSensor {
    listen(element, enabled = true) {
        const existing = this.sourceElement;
        if (element !== existing) {
            if (existing) {
                existing.removeEventListener('focusin', this.onFocusIn.bind(this), { capture: true });
                existing.removeEventListener('focusout', this.onFocusOut.bind(this), { capture: true });
            }
            this.sourceElement = element;
            if (element && enabled) {
                element.addEventListener('focusin', this.onFocusIn.bind(this), { capture: true });
                element.addEventListener('focusout', this.onFocusOut.bind(this), { capture: true });
            }
        }
    }
    reset() {
        this.doFocusOut();
    }
    onFocusIn(e) {
        this.doFocusIn(e);
        this.setPreventDefaultAndStopPropagation(e);
    }
    onFocusOut(e) {
        this.doFocusOut();
        this.setPreventDefaultAndStopPropagation(e);
    }
    doFocusIn(e) {
        this.preventDefault = false;
        this.stopPropagation = false;
        const path = e.composedPath();
        const { data, window } = (0, DataForSensor_1.grabElementData)(path, DataForSensor_1.SymDataForSensor, 'focus', this.elementDataList);
        this.elementDataList = toggleFocusRefs(this.elementDataList, data);
        this.revision++;
        (0, reactronic_1.standalone)(() => {
            var _a;
            (_a = this.windowSensor) === null || _a === void 0 ? void 0 : _a.setActiveWindow(window, 'focus');
        });
    }
    doFocusOut() {
        this.preventDefault = false;
        this.stopPropagation = false;
        this.revision++;
    }
}
__decorate([
    reactronic_1.transaction,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Boolean]),
    __metadata("design:returntype", void 0)
], FocusSensor.prototype, "listen", null);
__decorate([
    reactronic_1.transaction,
    (0, reactronic_1.options)({ trace: reactronic_1.TraceLevel.Silent }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [FocusEvent]),
    __metadata("design:returntype", void 0)
], FocusSensor.prototype, "doFocusIn", null);
__decorate([
    reactronic_1.transaction,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], FocusSensor.prototype, "doFocusOut", null);
exports.FocusSensor = FocusSensor;
function toggleFocusRefs(existing, updated) {
    if (updated !== existing) {
        existing.forEach(f => {
            if (f instanceof reactronic_1.ToggleRef && f.valueOn !== f.valueOff)
                f.value = f.valueOff;
        });
        updated.forEach(x => {
            if (x instanceof reactronic_1.ToggleRef)
                x.value = x.valueOn;
        });
    }
    return updated;
}
