"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HoverSensor = void 0;
const reactronic_1 = require("reactronic");
const DataForSensor_1 = require("./DataForSensor");
const KeyboardSensor_1 = require("./KeyboardSensor");
const BasePointerSensor_1 = require("./BasePointerSensor");
class HoverSensor extends BasePointerSensor_1.BasePointerSensor {
    constructor(window) {
        super(window);
        this.target = undefined;
        this.target = undefined;
    }
    listen(element, enabled = true) {
        const existing = this.sourceElement;
        if (element !== existing) {
            if (existing) {
                existing.removeEventListener('pointerover', this.onPointerOver.bind(this), { capture: true });
                existing.removeEventListener('pointerout', this.onPointerOut.bind(this), { capture: true });
            }
            this.sourceElement = element;
            if (element && enabled) {
                element.addEventListener('pointerover', this.onPointerOver.bind(this), { capture: true });
                element.addEventListener('pointerout', this.onPointerOut.bind(this), { capture: true });
            }
        }
    }
    onPointerOver(e) {
        this.doPointerOver(e);
    }
    onPointerOut(e) {
        this.doPointerOut();
    }
    doPointerOver(e) {
        var _a;
        this.preventDefault = false;
        this.stopPropagation = false;
        const targetPath = e.composedPath();
        const underPointer = document.elementsFromPoint(e.clientX, e.clientY);
        this.target = (_a = (0, DataForSensor_1.findTargetElementData)(targetPath, underPointer, DataForSensor_1.SymDataForSensor, ['hover']).data) === null || _a === void 0 ? void 0 : _a.hover;
        this.modifiers = (0, KeyboardSensor_1.extractModifierKeys)(e);
        this.positionX = e.clientX;
        this.positionY = e.clientY;
        this.revision++;
    }
    doPointerOut() {
        this.preventDefault = false;
        this.stopPropagation = false;
        this.positionX = Infinity;
        this.positionY = Infinity;
        this.modifiers = KeyboardSensor_1.KeyboardModifiers.None;
        this.target = undefined;
    }
}
__decorate([
    reactronic_1.transaction,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Boolean]),
    __metadata("design:returntype", void 0)
], HoverSensor.prototype, "listen", null);
__decorate([
    reactronic_1.transaction,
    (0, reactronic_1.options)({ trace: reactronic_1.TraceLevel.Silent }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [PointerEvent]),
    __metadata("design:returntype", void 0)
], HoverSensor.prototype, "doPointerOver", null);
__decorate([
    reactronic_1.transaction,
    (0, reactronic_1.options)({ trace: reactronic_1.TraceLevel.Silent }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], HoverSensor.prototype, "doPointerOut", null);
exports.HoverSensor = HoverSensor;
