import { HtmlElementSensor } from './HtmlElementSensor';
import { KeyboardModifiers } from './KeyboardSensor';
import { WindowSensor } from './WindowSensor';
export declare type DragEffectAllowed = 'none' | 'copy' | 'copyLink' | 'copyMove' | 'link' | 'linkMove' | 'move' | 'all' | 'uninitialized';
export declare type DropEffect = 'none' | 'copy' | 'link' | 'move';
export declare class HtmlDragSensor extends HtmlElementSensor {
    draggable: unknown;
    dragSource: unknown;
    dragTarget: unknown;
    previousDragTarget: unknown;
    dragStarted: boolean;
    dragFinished: boolean;
    startX: number;
    startY: number;
    private dataByFormat;
    dropEffect: DropEffect;
    dataTypesAllowed: string[];
    effectAllowed: DragEffectAllowed;
    dropAllowed: boolean;
    draggingOver: boolean;
    draggingDataTypes: string[];
    positionX: number;
    positionY: number;
    modifiers: KeyboardModifiers;
    dropX: number;
    dropY: number;
    dropped: boolean;
    immediatePositionX: number;
    immediatePositionY: number;
    immediateModifiers: KeyboardModifiers;
    constructor(windowSensor: WindowSensor);
    getData(format: string): unknown;
    setData(format: string, value: unknown): void;
    clearData(format?: string): void;
    listen(element: HTMLElement | undefined, enabled?: boolean): void;
    protected onDragStart(e: DragEvent): void;
    protected onDrag(e: DragEvent): void;
    protected onDragEnter(e: DragEvent): void;
    protected onDragLeave(e: DragEvent): void;
    protected onDragOver(e: DragEvent): void;
    protected onDrop(e: DragEvent): void;
    protected onDragEnd(e: DragEvent): void;
    protected startDragging(e: DragEvent): void;
    protected dragging(e: DragEvent): void;
    protected finishDragging(e: DragEvent): void;
    protected enterTarget(e: DragEvent): void;
    protected leaveTarget(e: DragEvent): void;
    protected dragOver(e: DragEvent): void;
    protected drop(e: DragEvent): void;
    protected updateEventOnDragStart(e: DragEvent): void;
    protected updateEventOnDropAllowed(e: DragEvent): void;
    protected reset(): void;
    protected updateDragTarget(e: DragEvent): unknown;
    protected whenDragging(): void;
}
