"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlSensors = void 0;
const reactronic_1 = require("reactronic");
const FocusSensor_1 = require("./FocusSensor");
const HoverSensor_1 = require("./HoverSensor");
const HtmlDragSensor_1 = require("./HtmlDragSensor");
const KeyboardSensor_1 = require("./KeyboardSensor");
const ButtonSensor_1 = require("./ButtonSensor");
const ResizeSensor_1 = require("./ResizeSensor");
const WheelSensor_1 = require("./WheelSensor");
const WindowSensor_1 = require("./WindowSensor");
const PointerSensor_1 = require("./PointerSensor");
class HtmlSensors {
    constructor() {
        this.window = new WindowSensor_1.WindowSensor();
        this.focus = new FocusSensor_1.FocusSensor(this.window);
        this.hover = new HoverSensor_1.HoverSensor();
        this.keyboard = new KeyboardSensor_1.KeyboardSensor();
        this.wheel = new WheelSensor_1.WheelSensor();
        this.resize = new ResizeSensor_1.ResizeSensor();
        this.htmlDrag = new HtmlDragSensor_1.HtmlDragSensor(this.window);
        this.button = new ButtonSensor_1.ButtonSensor(this.window);
        this.pointer = new PointerSensor_1.PointerSensor(this.window);
    }
    listen(element, enabled = true) {
        this.focus.listen(element, enabled);
        this.hover.listen(element, enabled);
        this.keyboard.listen(element, enabled);
        this.wheel.listen(element, enabled);
        this.htmlDrag.listen(element, enabled);
        this.button.listen(element, enabled);
        this.pointer.listen(element, enabled);
    }
}
__decorate([
    reactronic_1.transaction,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Boolean]),
    __metadata("design:returntype", void 0)
], HtmlSensors.prototype, "listen", null);
exports.HtmlSensors = HtmlSensors;
