import { HtmlElementSensor } from './HtmlElementSensor';
export declare enum KeyboardModifiers {
    None = 0,
    Ctrl = 1,
    Shift = 2,
    Alt = 4,
    Meta = 8,
    CtrlShift = 3,
    CtrlAlt = 5,
    CtrlMeta = 9,
    CtrlShiftAlt = 7,
    CtrlShiftAltMeta = 15,
    CtrlShiftMeta = 11,
    ShiftAlt = 6,
    ShiftMeta = 10,
    ShiftAltMeta = 14,
    AltMeta = 12
}
export declare class KeyboardSensor extends HtmlElementSensor {
    down: string;
    up: string;
    modifiers: KeyboardModifiers;
    constructor();
    listen(element: HTMLElement | undefined, enabled?: boolean): void;
    reset(): void;
    protected onKeyDown(e: KeyboardEvent): void;
    protected onKeyUp(e: KeyboardEvent): void;
    protected keyDown(e: KeyboardEvent): void;
    protected keyUp(e: KeyboardEvent): void;
    protected updateSensorData(e: KeyboardEvent): void;
    protected static getKeyAsModifierIfAny(key: string): KeyboardModifiers;
}
export declare function extractModifierKeys(e: MouseEvent | KeyboardEvent | WheelEvent): KeyboardModifiers;
