import { PointerButton, BasePointerSensor } from './BasePointerSensor';
import { KeyboardModifiers } from './KeyboardSensor';
import { WindowSensor } from './WindowSensor';
export declare class PointerSensor extends BasePointerSensor {
    pointerButton: PointerButton;
    private clickable;
    clicking: unknown;
    clicked: unknown;
    clickX: number;
    clickY: number;
    private tryingDragging;
    draggableData: unknown;
    dragSource: unknown;
    dragTarget: unknown;
    previousDragTarget: unknown;
    dragStarted: boolean;
    dragFinished: boolean;
    startX: number;
    startY: number;
    private draggingData;
    dropAllowed: boolean;
    draggingOver: boolean;
    positionX: number;
    positionY: number;
    modifiers: KeyboardModifiers;
    dropX: number;
    dropY: number;
    dropped: boolean;
    immediatePositionX: number;
    immediatePositionY: number;
    immediateModifiers: KeyboardModifiers;
    static readonly DraggingThreshold = 4;
    constructor(windowSensor: WindowSensor);
    getData(): unknown;
    setData(value: unknown): void;
    listen(element: HTMLElement | undefined, enabled?: boolean): void;
    protected onPointerDown(e: PointerEvent): void;
    protected onPointerMove(e: PointerEvent): void;
    protected onPointerUp(e: PointerEvent): void;
    protected onLostPointerCapture(e: PointerEvent): void;
    protected onKeyDown(e: KeyboardEvent): void;
    protected tryClickingOrDragging(e: PointerEvent): void;
    protected clickingOver(e: PointerEvent): void;
    protected click(e: PointerEvent): void;
    protected startDragging(e: PointerEvent): void;
    protected dragOver(e: PointerEvent): void;
    protected drop(e: PointerEvent): void;
    protected finishDragging(): void;
    protected cancelDragging(): void;
    protected reset(): void;
    protected updateClicking(e: PointerEvent): boolean;
    protected updateDragTarget(e: PointerEvent): unknown;
    protected whenClickingOrDragging(): void;
}
