"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResizeSensor = void 0;
const reactronic_1 = require("reactronic");
const Sensor_1 = require("./Sensor");
const RxDom_1 = require("../../core/RxDom");
class ResizeSensor extends Sensor_1.Sensor {
    constructor() {
        super();
        this.resizedElements = [];
        this.observer = new ResizeObserver(this.onResize.bind(this));
    }
    reset() {
        this.doReset();
    }
    observeResizeOfRenderingElement(value) {
        const self = RxDom_1.RxDom.currentNodeInstanceInternal();
        if (value) {
            if (self.resizing !== undefined && self.resizing !== this.observer)
                self.resizing.unobserve(self.native);
            self.resizing = this.observer;
            this.observer.observe(self.native);
        }
        else {
            if (self.resizing === this.observer) {
                this.observer.unobserve(self.native);
                self.resizing = undefined;
            }
        }
    }
    onResize(entries) {
        this.resize(entries);
        this.reset();
    }
    resize(entries) {
        this.revision++;
        this.resizedElements = entries.map(entry => {
            const element = entry.target;
            return {
                borderBoxSize: entry.borderBoxSize,
                contentBoxSize: entry.contentBoxSize,
                contentRect: entry.contentRect,
                resizeData: element.dataForSensor.resize,
            };
        });
    }
    doReset() {
        this.resizedElements = [];
    }
}
__decorate([
    reactronic_1.transaction,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ResizeSensor.prototype, "reset", null);
__decorate([
    reactronic_1.transaction,
    (0, reactronic_1.options)({ trace: reactronic_1.TraceLevel.Silent }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array]),
    __metadata("design:returntype", void 0)
], ResizeSensor.prototype, "resize", null);
exports.ResizeSensor = ResizeSensor;
